/**
 * 
 */
package com.b510.irregularverbs.lib;

import java.util.ArrayList;
import java.util.List;

import com.b510.irregularverbs.vo.IrregularVerbsVO;

/**
 * @author Hongten
 * @created Feb 27, 2014
 */
public class IrregularVerbs {
	
	private static IrregularVerbs irregularVerbs = new IrregularVerbs();
	private static List<IrregularVerbsVO> verbs = new ArrayList<IrregularVerbsVO>();

	public static List<IrregularVerbsVO> getVerbsLib() {
		verbs.add(new IrregularVerbsVO("be", "was", "been", "be动词"));
		verbs.add(new IrregularVerbsVO("be", "were", "been", "be动词"));
		verbs.add(new IrregularVerbsVO("know", "knew", "known", "知道"));
		verbs.add(new IrregularVerbsVO("leap", "leaped", "leaped", "跳跃"));
		verbs.add(new IrregularVerbsVO("leap", "leapt", "leapt", "跳跃"));
		verbs.add(new IrregularVerbsVO("let", "let", "let", "让"));
		return verbs;
	}
	
	private IrregularVerbs() {
	}
	
	public static IrregularVerbs getInstance(){
		if(verbs.size() <= 0){
			getVerbsLib();
		}
		return irregularVerbs;
	}

	public void match(String input) {
		long startTime = System.currentTimeMillis();
		List<IrregularVerbsVO> temp = new ArrayList<IrregularVerbsVO>();
		List<IrregularVerbsVO> mayBeVOs = new ArrayList<IrregularVerbsVO>();
		for (IrregularVerbsVO vo : verbs) {
			if (input.equalsIgnoreCase(vo.getPrototype()) || input.equalsIgnoreCase(vo.getPostTense()) || input.equalsIgnoreCase(vo.getPostParticiple())) {
				temp.add(vo);
			}
			if(vo.getPrototype().startsWith(input) || vo.getPostTense().startsWith(input)|| vo.getPostParticiple().startsWith(input)){
				mayBeVOs.add(vo);
			}
		}
		System.out.println("=============================================");
		if (temp.size() > 0) {
			for (IrregularVerbsVO vo : temp) {
				System.out.println(vo.getPrototype() + "       " + vo.getPostTense() + "        " + vo.getPostParticiple() + "            " + vo.getMean());
			}
		} else {
			System.out.println("no matched!");
			if(mayBeVOs.size() > 0){
				System.out.println("=====================");
				System.out.println("You may want to search the follow word(s):");
				for (IrregularVerbsVO vo : mayBeVOs) {
					System.out.println(vo.getPrototype() + "       " + vo.getPostTense() + "        " + vo.getPostParticiple() + "            " + vo.getMean());
				}
			}
		}
		long endTime = System.currentTimeMillis();
		System.out.println("Spend >> [" + (endTime - startTime) + "]ms");
		System.out.println("=============================================\n\n\n\n\n");
	}
}
